src.structures (28 February 2006) | index /Users/d3y382/workspaces/apbs/pdb2pqr/branches/pdb2pqr-1.8/src/structures.py

`Structures for PDB2PQR
This module contains the structure objects used in PDB2PQR and their
associated methods.
----------------------------
PDB2PQR -- An automated pipeline for the setup, execution, and analysis of
Poisson-Boltzmann electrostatics calculations
Copyright (c) 2002-2011, Jens Erik Nielsen, University College Dublin;
Nathan A. Baker, Battelle Memorial Institute, Developed at the Pacific
Northwest National Laboratory, operated by Battelle Memorial Institute,
Pacific Northwest Division for the U.S. Department Energy.;
Paul Czodrowski & Gerhard Klebe, University of Marburg.
All rights reserved.
Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:
* Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.
* Neither the names of University College Dublin, Battelle Memorial Institute,
Pacific Northwest National Laboratory, US Department of Energy, or University
of Marburg nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
OF THE POSSIBILITY OF SUCH DAMAGE.
----------------------------`

Modules

``

copy math | os string | sys |

Classes

``

src.pdb.ATOM
  Atom
Chain
Residue

class Atom(src.pdb.ATOM)
`` | `Class Atom The Atom class inherits off the ATOM object in pdb.py. It is used for adding fields not found in the pdb that may be useful for analysis. Also simplifies code by combining ATOM and HETATM objects into a single class.`

Methods defined here:

__init__(self, atom, type, residue)
  `Initialize the new Atom object by using the old object.
  Parameters
  atom: The original ATOM object (ATOM)
  type: Either ATOM or HETATM (string)
  residue: A pointer back to the parent residue object (Residue)`

__str__(self)
  `Returns a string of the new atom type. Uses the ATOM string
  output but changes the first field to either by ATOM or
  HETATM as necessary.
  This is used to create the output for pqr files! No touchy!
  Returns
  str: String with ATOM/HETATM field set appropriately`

addBond(self, bondedatom)
  `Add a bond to the list of bonds
  Parameters:
  bondedatom: The atom to bond to (Atom)`

get(self, name)
  `Get a member of the Atom class
  Parameters
  name: The name of the member (string)
  Possible Values
  type: The type of Atom (either ATOM or HETATM)
  serial: Atom serial number
  name: Atom name
  altLoc: Alternate location
  resName: Residue name
  chainID: Chain identifier
  resSeq: Residue sequence number
  iCode: Code for insertion of residues
  x: Orthogonal coordinates for X in Angstroms.
  y: Orthogonal coordinates for Y in Angstroms.
  z: Orthogonal coordinates for Z in Angstroms.
  occupancy: Occupancy
  tempFactor: Temperature Factor
  segID: Segment identifier
  element: Element symbol
  charge: Charge on the atom
  bonds: The bonds associated with the atom
  interbonds: The intrabonds associated with the atom
  extrabonds: The extrabonds assocaited with the atom
  residue: The parent residue of the atom
  radius: The radius of the atom
  ffcharge: The forcefield charge on the atom
  hdonor: Whether the atom is a hydrogen donor
  hacceptor: Whether the atom is a hydrogen acceptor
  Returns
  item: The value of the member`

getCommonStringRep(self, chainflag=False)
  `Returns a string of the common column of the new atom type.
  Uses the ATOM string output but changes the first field
  to either by ATOM or HETATM as necessary.
  This is used to create the output for pqr and pdb files! No touchy!
  Returns
  outstr: String with ATOM/HETATM field set appropriately`

getCoords(self)
  `Return the x,y,z coordinates of the atom in list form
  Returns
  List of the coordinates (list)`

getPDBString(self)
  `Returns a string of the new atom type. Uses the ATOM string
  output but changes the first field to either by ATOM or
  HETATM as necessary.
  This is for the pdb representation of the atom. The propka30 module
  depends on this being correct. No touchy!
  Returns
  str: String with ATOM/HETATM field set appropriately`

getPQRString(self, chainflag=False)
  `Returns a string of the new atom type. Uses the ATOM string
  output but changes the first field to either by ATOM or
  HETATM as necessary.
  This is used to create the output for pqr files! No touchy!
  Returns
  str: String with ATOM/HETATM field set appropriately`

hasReference(self)
  `Determine if the atom object has a reference object or not.
  All known atoms should have reference objects.
  Returns
  True if atom has a reference object, False otherwise.`

isBackbone(self)
  `Return true if atom name is in backbone, otherwise false
  Returns
  state: 1 if true, 0 if false`

isHydrogen(self)
  `Is this atom a Hydrogen atom?
  Returns
  value: 1 if Atom is a Hydrogen, 0 otherwise`

set(self, name, value)
  `Set a member of the Atom class
  Parameters
  name: The name of the member (string)
  value: The value to set the member to
  Possible Values
  type: The type of Atom (either ATOM or HETATM)
  serial: Atom serial number
  name: Atom name
  altLoc: Alternate location
  resName: Residue name
  chainID: Chain identifier
  resSeq: Residue sequence number
  iCode: Code for insertion of residues
  x: Orthogonal coordinates for X in Angstroms.
  y: Orthogonal coordinates for Y in Angstroms.
  z: Orthogonal coordinates for Z in Angstroms.
  occupancy: Occupancy
  tempFactor: Temperature Factor
  segID: Segment identifier
  element: Element symbol
  charge: Charge on the atom
  residue: The parent residue of the atom
  radius: The radius of the atom
  ffcharge: The forcefield charge on the atom
  hdonor: Whether the atom is a hydrogen donor
  hacceptor: Whether the atom is a hydrogen acceptor`

class Chain
`` | `Chain class The chain class contains information about each chain within a given Protein object.`

Methods defined here:

__init__(self, chainID)
  `Initialize the class
  Parameters
  chainID: The chainID for this chain as denoted in
  the PDB file (string)`

addResidue(self, residue)
  `Add a residue to the chain
  Parameters
  residue: The residue to be added (Residue)`

get(self, name)
  `Get a member of the Chain class
  Parameters
  name: The name of the member
  Possible Values
  ID: The ID of the chain
  Residues: The list of residues within the Chain
  Returns
  item: The value of the member`

getAtoms(self)
  `Return a list of Atom objects contained in this chain
  Returns
  atomlist: List of Atom objects (list)`

getResidues(self)
  `Return a list of Residue objects in this chain`

getSummary(self)

numAtoms(self)
  `Get the number of atoms for the chain
  Returns
  count: Number of atoms in the chain (int)`

numResidues(self)
  `Get the number of residues for the chain
  Returns
  count: Number of residues in the chain (int)`

renumberResidues(self)
  `Renumber Atoms based on actual Residue number and not PDB resSeq`

class Residue
`` | `Residue class The residue class contains a list of Atom objects associated with that residue and other helper functions.`

Methods defined here:

__init__(self, atoms)
  `Initialize the class
  Parameters
  atoms: A list of Atom objects to be stored in this class
  (list)`

__str__(self)
  `Basic string representation for debugging`

addAtom(self, atom)
  `Add the atom object to the residue.
  Parameters
  atom: The object to be added (ATOM)`

addMissing(self, value)
  `Add the value to the list of missing atoms
  Parameters
  value: The name of the missing atom (string)`

createAtom(self, name, newcoords, type)
  `Add a new atom object to the residue. Uses an atom
  currently in the residue to seed the new atom
  object, then replaces the coordinates and name accordingly.
  Parameters
  name: The name of the new atom (string)
  newcoords: The x,y,z coordinates of the new atom (list)
  type: The type of atom, ATOM or HETATM`

get(self, name)
  `Get a member of the Residue class
  Parameters
  name: The name of the member (string)
  Possible Values
  atoms: The atoms in the residue
  name: The name of the residue
  chainID: The chainID associated with the residue
  resSeq: The sequence number of the residue
  icode: The iCode of the residue
  SSbonded: 1 if the residue has a SS bond, 0 otherwise
  SSbondpartner: The residue of the bond partner
  type: The type associated with this residue
  isNterm: # of hydrogens if the residue is the N-Terminus, 0 otherwise
  isCterm: 1 if the residue is the C-Terminus, 0 otherwise
  missing: List of missing atoms of the residue
  Returns
  item: The value of the member`

getAtom(self, name)
  `Retrieve an atom from the mapping
  Parameters
  resname: The name of the residue to retrieve (string)`

getAtoms(self)

getCharge(self)
  `Get the total charge of the residue. In order to get rid
  of floating point rounding error, do the string
  transformation.
  Returns:
  charge: The charge of the residue (float)`

hasAtom(self, name)

letterCode(self)

numAtoms(self)
  `Get the number of atoms for the residue
  Returns
  Number of atoms in the residue (int)`

removeAtom(self, atomname)
  `Remove an atom from the residue object.
  Parameters
  atomname: The name of the atom to be removed (string)`

renameAtom(self, oldname, newname)
  `Rename an atom to a new name
  Parameters
  oldname: The old atom name (string)
  newname: The new atom name (string)`

renameResidue(self, name)
  `Rename a given residue
  Parameters
  name: The new name of the residue`

reorder(self)
  `Reorder the atoms to start with N, CA, C, O if they exist`

rotateTetrahedral(self, atom1, atom2, angle)
  `Rotate about the atom1-atom2 bond by a given angle
  All atoms connected to atom2 will rotate.
  Parameters:
  atom1: The first atom of the bond to rotate about (atom)
  atom2: The second atom of the bond to rotate about (atom)
  angle: The number of degrees to rotate (float)`

set(self, name, value)
  `Set a member of the Residue class to a specific value
  Parameters
  name: The name of the object to set (string)
  value: The object to append
  Possible Values
  atoms: The atoms in the residue
  name: The name of the residue
  chain: The chainID associated with the residue
  resSeq: The sequence number of the residue
  icode: The iCode of the residue
  SSbonded: 1 if the residue has a SS bond, 0 otherwise
  SSbondpartner: The residue of the bond partner
  type: The type associated with this residue
  isNterm: # of hydrogens if the residue is the N-Terminus, 0 otherwise
  isCterm: 1 if the residue is the C-Terminus, 0 otherwise
  isDirty: 1 if the residue is not missing atoms,
  0 otherwise
  Notes
  resSeq points to the residue.setResSeq function
  Returns
  item: The value of the member`

setChainID(self, value)
  `Set the chainID field to a certain value`

setDonorsAndAcceptors(self)
  `Set the donors and acceptors within the residue`

setResSeq(self, value)
  `Set the atom field resSeq to a certain value and
  change the residue's information. The icode field is no longer
  useful.
  Parameters
  value: The new value of resSeq (int)`

update_terminus_status(self)
  `Update the isNterms and isCterm flags`

Data
`` |  | BACKBONE = ['N', 'CA', 'C', 'O', 'O2', 'HA', 'HN', 'H', 'tN'] DIHEDRAL = 57.2958 INSTALLDIR = '/Users/d3y382/pdb2pqr/' SMALL = 9.9999999999999995e-08 TMPDIR = 'tmp/' __author__ = 'Todd Dolinsky' __date__ = '28 February 2006'

Author
`` |  | Todd Dolinsky